﻿using System;
using System.Collections.Generic;
using System.Linq;
//using System.Web;
using AutomationHub.Models;

namespace AutomationHub.DAL
{
    public class AutoHubDBService
    {
        autohubEntities DbContext;
        public AutoHubDBService()
        {
            DbContext = new autohubEntities();
        }

        public string GetCodeById(int id)
        {
            try
            {
                var thisCode = (from c in DbContext.AutoHubCodes
                                where id == c.Id
                                select c).First();
                AutoHubLog l = new AutoHubLog();
                l.CodeKey = thisCode.Id;
                l.RequestedFrom = "TODO:Get Client URI here!";
                l.RequestedByAction = "TODO: Get SignalR Client URI here ";
                DbContext.AutoHubLogs.Add(l);
                int logId = DbContext.SaveChanges();               
                return String.Format("{0}", thisCode.AutoCodeVal);

            }
            catch (Exception Ex)
            {
               return String.Format("FAILED! Request for code [{0}] failed with the following error : {1} ", id.ToString(), Ex.Message);
            }
        }

        public string GetCodeByKey(string codeKey)
        {
            try
            {
                var thisCode = (from c in DbContext.AutoHubCodes
                                where codeKey.ToLower() == c.AutoCodeKey.ToLower()
                                select c).First();
                AutoHubLog l = new AutoHubLog();
                l.CodeKey = thisCode.Id;
                l.RequestedFrom = "TODO:Get Client URI here!";
                l.RequestedByAction = "TODO: Get SignalR Client URI here ";
                DbContext.AutoHubLogs.Add(l);
                int logId = DbContext.SaveChanges();
                return String.Format("{0}", thisCode.AutoCodeVal);

            }
            catch (Exception Ex)
            {
                return String.Format("FAILED! Request for code [{0}] failed with the following error : {1} ", codeKey, Ex.Message);
            }
        }

    }
}